Unit InpForm;
Interface
Uses
    SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
    Forms, Dialogs, StdCtrls;
Type
    TInputForm = Class(TForm)
        Label1: TLabel;
        Edit1: TEdit;
        Button1: TButton;
        Button2: TButton;
        Procedure GetNumber(Capt, Tex: String);
        Procedure Button1Click(Sender: TObject);
        Procedure FormShow(Sender: TObject);
        Procedure Button2Click(Sender: TObject);
        Procedure FormClose(Sender: TObject; var Action: TCloseAction);
    End;
Var
    InputForm: TInputForm;
    InpNum: LongInt;

Implementation
{$R *.DFM}
Uses
    LCalc3, LCore2;

Procedure TInputForm.GetNumber;
Begin
    LCalc.Disable;
    Caption:= Capt;
    Label1.Caption:= Tex;
    Show;
End;

Procedure TInputForm.Button1Click(Sender: TObject);
Begin
    Try
        InpNum:= StrToInt(Edit1.Text);
    Except
        Application.MessageBox('   ', AppName, 16);
        Exit;
    End;
    If Not (InpNum In [0, 2..36]) Then Begin
        Application.MessageBox('    2  36', AppName, 16);
        Exit;
    End;
    Config.UserSystem:= Byte(InpNum);
    Config.CountSystem:= TAll;
    LCore2.SetUserCC(Config.UserSystem);
    InputForm.Close
End;

Procedure TInputForm.FormShow(Sender: TObject);
Begin
    Left:= LCalc.Left;
    Top:= LCalc.Top + 23;
End;

Procedure TInputForm.Button2Click(Sender: TObject);
Begin
    InputForm.Close;
End;

Procedure TInputForm.FormClose(Sender: TObject; Var Action: TCloseAction);
Begin
    Hide;
    LCalc.Enable;
    LCalc.SetFocus;
End;

End.

