{
          .
     NumCalc    .
:  .
    .    )
  !}
{$I+}
{$R-}
{$A-}
Unit Lcalc3;
Interface
Uses
    SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
    Forms, Dialogs, StdCtrls, Menus, ClipBrd, LCore2, LMath, InpForm, VarsF,
    ButF, Help, About;
Type
    TLCalc = Class(TForm)
        Edit1: TEdit;
        ListBox1: TListBox;
        PopupMenu1: TPopupMenu;
        N1: TMenuItem; N2: TMenuItem; N3: TMenuItem;
        N4: TMenuItem; N7: TMenuItem; N8: TMenuItem;
        N9: TMenuItem; N10: TMenuItem; N11: TMenuItem;
        N12: TMenuItem; N13: TMenuItem; N14: TMenuItem;
        N15: TMenuItem; N16: TMenuItem; N5: TMenuItem;
        N17: TMenuItem; N6: TMenuItem; C1: TMenuItem;
        N18: TMenuItem; N19: TMenuItem; N20: TMenuItem;
        N21: TMenuItem; N22: TMenuItem; N23: TMenuItem;
        N24: TMenuItem; N25: TMenuItem; N26: TMenuItem;
        N27: TMenuItem; N28: TMenuItem; N29: TMenuItem;
        N30: TMenuItem; N31: TMenuItem; N32: TMenuItem;
        N33: TMenuItem; N34: TMenuItem; N35: TMenuItem;
        N36: TMenuItem; N37: TMenuItem; N38: TMenuItem;
        N39: TMenuItem;
        All1: TMenuItem; Bin1: TMenuItem;
        Dec1: TMenuItem; Hex1: TMenuItem;
        FontDialog1: TFontDialog;
        ColorDialog1: TColorDialog;
        SaveDialog1: TSaveDialog;
        OpenDialog1: TOpenDialog;
        Oct1: TMenuItem; Sep6: TMenuItem; UserBase: TMenuItem;
        N40: TMenuItem; N41: TMenuItem; N42: TMenuItem;
        N43: TMenuItem; N44: TMenuItem;
        Procedure Edit1KeyPress(Sender: TObject; Var Key: Char);
        Procedure ListBox1Click(Sender: TObject);
        Procedure FormResize(Sender: TObject);
        Procedure FormCreate(Sender: TObject);
        Procedure FormClose(Sender: TObject; Var Action: TCloseAction);
        Procedure N9Click(Sender: TObject);
        Procedure N10Click(Sender: TObject);
        Procedure N12Click(Sender: TObject);
        Procedure N13Click(Sender: TObject);
        Procedure N17Click(Sender: TObject);
        Procedure N2Click(Sender: TObject);
        Procedure N1Click(Sender: TObject);
        Procedure N3Click(Sender: TObject);
        Procedure PopupMenu1Popup(Sender: TObject);
        Procedure N4Click(Sender: TObject);
        Procedure C1Click(Sender: TObject);
        Procedure N18Click(Sender: TObject);
        Procedure N21Click(Sender: TObject);
        Procedure N22Click(Sender: TObject);
        Procedure N24Click(Sender: TObject);
        Procedure N26Click(Sender: TObject);
        Procedure N25Click(Sender: TObject);
        Procedure N31Click(Sender: TObject);
        Procedure N28Click(Sender: TObject);
        Procedure N30Click(Sender: TObject);
        Procedure N29Click(Sender: TObject);
        Procedure N33Click(Sender: TObject);
        Procedure N34Click(Sender: TObject);
        Procedure N35Click(Sender: TObject);
        Procedure Bin1Click(Sender: TObject);
        Procedure Dec1Click(Sender: TObject);
        Procedure Hex1Click(Sender: TObject);
        Procedure All1Click(Sender: TObject);
        Procedure Oct1Click(Sender: TObject);
        Procedure Disable;
        Procedure Enable;
        Procedure N40Click(Sender: TObject);
        Procedure N41Click(Sender: TObject);
        Procedure UserBaseClick(Sender: TObject);
        Procedure N42Click(Sender: TObject);
        Procedure CSCheck;
        Procedure N38Click(Sender: TObject);
        Procedure N44Click(Sender: TObject);
        Procedure N37Click(Sender: TObject);
        Procedure N15Click(Sender: TObject);
        Procedure N16Click(Sender: TObject);
        Procedure AssignF;
    End;
    TWindow = Record
        FormTop, FormLeft, FormHeight, FormWidth: Integer;
        FormMax: Boolean;
    End;
    TDamnedFont = Record
        Color: TColor;
        Handle: HFont;
        Height: Integer;
        Name: String[32];
        Pitch: TFontPitch;
        PixelsPerInch: Integer;
        Size: Integer;
        Style: TFontStyles;
    End;
    TCountSyst = (TBin, TOct, TDec, THex, TUser, TAll);
    TConfig = Object
        EditFont, ListBoxFont: TDamnedFont;
        EditColor, FormColor, ListBoxColor: TColor;
        Window, VarsWindow, ButtWindow: TWindow;
        EditAutoFocus, EditAutoSelect, AutoSave,
        ListBoxClip, UsingDegrees_, ChainCalculation: Boolean;
        CaptResult, VarPanelActive, ButPanelActive: Boolean;
        CountSystem: TCountSyst;
        UserSystem: Byte;
        Procedure Init;
        Function Read: Boolean;
        Procedure Write;
        Procedure SetStandartWindow;
        Procedure SetCurrentWindow;
        Procedure SetCurrentFont(Var EFont, LBFont: TDamnedFont);
        Procedure ApplyFont(Var EFont, LBFont: TDamnedFont);
    End;
Var
    LCalc: TLCalc;
    VarF: TVarF;
    ButtF: TButtF;
    HelpF: THelpF;
    AboutF: TAboutF;
    Config: TConfig;
    Temp: Integer;
    Tex, FName, LogFName: String;
    FD: File;
    ErrLogFD: TextFile;
Const
    LogFilter = 'LeftCalc Log (*.LCL)|*.LCL';
    VarFilter = 'LeftCalc Variables (*.LCV)|*.LCV';
    UserSystemText = '';
    AppName = 'LeftCalc';

Implementation
{$R *.DFM}
Procedure TLCalc.AssignF;
Begin
    AssignFile(ErrLogFD, 'errors.log');
    Try
        Append(ErrLogFD);
    Except
        On Exception Do Begin
            ReWrite(ErrLogFD);
            WriteLn(ErrLogFD, Application.Title);
            CloseFile(ErrLogFD);
            Append(ErrLogFD);
        End;
    End;
    WriteLn(ErrLogFD, Edit1.Text + '  [' + Tex + ']');
    CloseFile(ErrLogFD);
End;

Procedure TLCalc.Edit1KeyPress(Sender: TObject; Var Key: Char);
Begin
    If Ord(Key) = 13 Then Begin
        Key:= Chr(0);
        Solve(Edit1.Text, Config.UsingDegrees_);
        VarF.UpDateIt;
        If Result.ErrCode <> 0 Then Begin
            Case Result.ErrCode Of
              1: Tex:= '    ';
              2: Tex:= ' ';
              3: Tex:= ' ';
              4: Tex:= '   ';
              5: Tex:= '  ';
              6: Tex:= '  ';
              7: Tex:= '   ';
              8:
                Begin
                    Tex:= '    ';
                    AssignF;
                End;
              9:
                Begin
                    Tex:= '   ';
                    AssignF;
                End;
              10: Tex:= '  ';
              11: Tex:= '         ';
              12: Tex:= '    ';
              13: Tex:= '       ';
              14: Tex:= '     ';
              15: Tex:= '    ';
              16: Tex:= '  ';
              17: Tex:= '     ';
              18: Tex:= ' ';
              19: Tex:= '   ';
              20: Tex:= '';
              21: Tex:= '  ,     ';
              22: Tex:= '   ';
              23: Tex:= '   ';
              24: Tex:= '   ';
              25: Tex:= '';
              26: Tex:= ' ' + Result.ResStr;
            End;
            ListBox1.Items.Add(Edit1.Text + '  [' + Tex + ']');
            If Config.CaptResult Then LCalc.Caption:= '(' + Tex + ')';
        End
        Else Try
            Case Config.CountSystem Of
              TBin:
                Tex:= ExtendedToOtherCC(StrToFloat(Result.ResStr), 2) + 'b';
              TOct:
                Tex:= ExtendedToOtherCC(StrToFloat(Result.ResStr), 8) + 'o ';
              TDec:
                Tex:= Result.ResStr;
              THex:
                Tex:= ExtendedToOtherCC(StrToFloat(Result.ResStr), 16) + 'h';
              TAll:
                Begin
                    Tex:= Result.ResStr + ' (' + ExtendedToOtherCC(StrToFloat(Result.ResStr), 2)
                    + 'b, ' + ExtendedToOtherCC(StrToFloat(Result.ResStr), 8)
                    + 'o, ' + ExtendedToOtherCC(StrToFloat(Result.ResStr), 16) + 'h)';
                    If Config.UserSystem > 0 Then
                    Insert(', ' + ExtendedToOtherCC(StrToFloat(Result.ResStr), Config.UserSystem) + 'u', Tex, Length(Tex));
                End;
              TUser:
                Tex:= ExtendedToOtherCC(StrToFloat(Result.ResStr), Config.UserSystem) + 'u ';
            End;
            ListBox1.Items.Add(Edit1.Text + '=' + Tex);
            If Config.CaptResult Then LCalc.Caption:= '(' + Tex + ')';
        Except
            On EInvalidOp Do Begin
                ListBox1.Items.Add('      ');
                Exit;
            End;
        End;
        ListBox1.ItemIndex:= ListBox1.Items.Count - 1;
        If Config.EditAutoSelect Then Begin
            Edit1.SelStart:= 0;
            Edit1.SelLength:= Length(Edit1.Text);
        End;
    End
    Else If Config.ChainCalculation And
    (Key In ['+', '-', '*', '/', '\', '^', '>', '<', '=', ' ']) And
    (Edit1.SelStart = 0) And (Edit1.SelLength = Length(Edit1.Text)) Then Begin
        Edit1.Text:= Result.ResStr;
        Edit1.SelStart:= Length(Edit1.Text);
    End;
    VarF.Refresh;
End;

Procedure TLCalc.ListBox1Click(Sender: TObject);
Begin
    Tex:= ListBox1.Items[ListBox1.ItemIndex]; Temp:= Length(Tex);
    Repeat
        Dec(Temp);
        If Tex[Temp] In ['=', '['] Then Begin
            Dec(Temp);
            While Tex[Temp] = ' ' Do Dec(Temp);
            Tex:= Copy(Tex, 1, Temp);
            Break;
        End;
    Until Temp = 0;
    Edit1.Text:= Tex;
    If Config.CaptResult Then LCalc.Caption:= AppName + ' (' + Result.ResStr + ')';
    If Config.EditAutoFocus Then Edit1.SetFocus;
End;

Procedure TLCalc.FormResize(Sender: TObject);
Begin
    Edit1.Left:= 5; ListBox1.Left:= 5;
    Edit1.Width:= LCalc.Width - 17;
    ListBox1.Width:= Edit1.Width;
    ListBox1.Top:= Edit1.Top + Edit1.Height + 5;
    ListBox1.Height:= LCalc.Height - ListBox1.Top - 40;
End;

Procedure TConfig.Init;
Begin
    With Config Do Begin
        If Not Read Then Begin
            SetStandartWindow;
            SetCurrentFont(EditFont, ListBoxFont);
            EditAutoFocus:= False; AutoSave:= True;
            EditAutoSelect:= False; ListBoxClip:= False;
            UsingDegrees_:= False; ChainCalculation:= False;
            CaptResult:= False; CountSystem:= TDec;
            CaptResult:= False;
            VarPanelActive:= False; ButPanelActive:= False;
            ListBoxColor:= LCalc.ListBox1.Color;
            EditColor:= LCalc.Edit1.Color;
            FormColor:= LCalc.Color;
            UserSystem:= 0;
            LCalc.Position:= PoScreenCenter;
            Write;
        End
        Else Begin
            ApplyFont(EditFont, ListBoxFont);
            LCalc.ListBox1.Color:= ListBoxColor;
            LCalc.Edit1.Color:= EditColor;
            LCalc.Color:= FormColor;
        End;
        With LCalc Do Begin
            N12.Checked:= EditAutoFocus;
            N13.Checked:= AutoSave;
            N10.Checked:= Not UsingDegrees_;
            N9.Checked:= UsingDegrees_;
            N18.Checked:= EditAutoSelect;
            N31.Checked:= ChainCalculation;
            N42.Checked:= CaptResult;
            N38.Checked:= VarPanelActive;
            N37.Checked:= ButPanelActive;
            CSCheck;
            LCore2.SetUserCC(Config.UserSystem);
        End;
    End;
End;

Procedure TConfig.Write;
Begin
    Try
        AssignFile(FD, 'LeftCalc.Bin');
        ReWrite(FD, 1);
        BlockWrite(FD, Config, SizeOf(Config));
        CloseFile(FD);
    Except
        LCalc.ListBox1.Items.Add('    ');
    End;
End;

Function TConfig.Read: Boolean;
Begin
    Try
        AssignFile(FD, 'LeftCalc.Bin');
        Reset(FD, 1);
        BlockRead(FD, Config, SizeOf(Config));
        CloseFile(FD);
        Read:= True;
    Except
        Read:= False;
    End;
End;

Procedure TConfig.SetStandartWindow;
Begin
    With Config.Window Do Begin
        FormWidth:= 400; FormHeight:= 200;
        FormLeft:= 0; FormTop:= 0; FormMax:= False;
    End;
    With Config.VarsWindow Do Begin
        FormWidth:= 200; FormHeight:= 200;
        FormLeft:= Config.Window.FormLeft + Config.Window.FormWidth;
        FormTop:= Config.Window.FormTop; FormMax:= False;
    End;
    With Config.ButtWindow Do Begin
        FormWidth:= 311; FormHeight:= 232;
        FormLeft:= Config.Window.FormLeft;
        FormTop:= Config.Window.FormTop + Config.Window.FormHeight;
        FormMax:= False;
    End;
End;

Procedure TConfig.SetCurrentWindow;
Begin
    Config.Window.FormMax:= LCalc.WindowState = WSMaximized;
    If Not Config.Window.FormMax Then With Config.Window Do Begin
        FormWidth:= LCalc.Width; FormHeight:= LCalc.Height;
        FormLeft:= LCalc.Left; FormTop:= LCalc.Top;
    End;
    Config.VarsWindow.FormMax:= VarF.WindowState = WSMaximized;
    If Not Config.VarsWindow.FormMax Then With Config.VarsWindow Do Begin
        FormWidth:= VarF.Width; FormHeight:= VarF.Height;
        FormLeft:= VarF.Left; FormTop:= VarF.Top;
    End;
    Config.ButtWindow.FormMax:= ButtF.WindowState = WSMaximized;
    If Not Config.ButtWindow.FormMax Then With Config.ButtWindow Do Begin
        FormWidth:= ButtF.Width; FormHeight:= ButtF.Height;
        FormLeft:= ButtF.Left; FormTop:= ButtF.Top;
    End;
End;

Procedure TConfig.SetCurrentFont(Var EFont, LBFont: TDamnedFont);
Begin
    With LCalc Do Begin
        EFont.Name:= Edit1.Font.Name;
        EFont.Size:= Edit1.Font.Size;
        EFont.Color:= Edit1.Font.Color;
        EFont.Style:= Edit1.Font.Style;
        EFont.Height:= Edit1.Font.Height;
        LBFont.Name:= ListBox1.Font.Name;
        LBFont.Size:= ListBox1.Font.Size;
        LBFont.Color:= ListBox1.Font.Color;
        LBFont.Style:= ListBox1.Font.Style;
        LBFont.Height:= ListBox1.Font.Height;
        {EFont:= Edit1.Font;
        LBFont:= ListBox1.Font; }
    End;
End;

Procedure TConfig.ApplyFont(Var EFont, LBFont: TDamnedFont);
Begin
    With LCalc Do Begin
        Edit1.Font.Name:= EFont.Name;
        Edit1.Font.Size:= EFont.Size;
        Edit1.Font.Color:= EFont.Color;
        Edit1.Font.Style:= EFont.Style;
        Edit1.Font.Height:= EFont.Height;
        ListBox1.Font.Name:= LBFont.Name;
        ListBox1.Font.Size:= LBFont.Size;
        ListBox1.Font.Color:= LBFont.Color;
        ListBox1.Font.Style:= LBFont.Style;
        ListBox1.Font.Height:= LBFont.Height;
        {Edit1.Font:= EFont;
        ListBox1.Font:= LBFont;}
    End;
End;

Procedure TLCalc.FormCreate(Sender: TObject);
Begin
    Config.Init;
    With Config.Window Do Begin
        LCalc.Width:= FormWidth; LCalc.Height:= FormHeight;
        LCalc.Left:= FormLeft; LCalc.Top:= FormTop;
        If FormMax Then LCalc.WindowState:= WSMaximized;
    End;
End;

Procedure TLCalc.FormClose(Sender: TObject; Var Action: TCloseAction);
Begin
    With Config Do If AutoSave Then Begin
        SetCurrentFont(EditFont, ListBoxFont);
        SetCurrentWindow;
        Write;
    End;
End;

Procedure TLCalc.N9Click(Sender: TObject);
Begin
    If Not Config.UsingDegrees_ Then Begin
        Config.UsingDegrees_:= True;
        N9.Checked:= True;
        N10.Checked:= Not Config.UsingDegrees_;
    End;
End;

Procedure TLCalc.N10Click(Sender: TObject);
Begin
    If Config.UsingDegrees_ Then Begin
        Config.UsingDegrees_:= False;
        N10.Checked:= True;
        N9.Checked:= Config.UsingDegrees_;
    End;
End;

Procedure TLCalc.N12Click(Sender: TObject);
Begin
    Config.EditAutoFocus:= Not Config.EditAutoFocus;
    N12.Checked:= Not N12.Checked;
End;

Procedure TLCalc.N13Click(Sender: TObject);
Begin
    Config.AutoSave:= Not Config.AutoSave;
    N13.Checked:= Not N13.Checked;
End;

Procedure TLCalc.N17Click(Sender: TObject);
Begin
    ListBox1.Clear;
End;

Procedure TLCalc.N2Click(Sender: TObject);
Begin
    Config.ListBoxClip:= False;
    If Edit1.Focused Then
        Edit1.CutToClipBoard
    Else If ListBox1.Focused And (ListBox1.ItemIndex >= 0) Then Begin
        Config.ListBoxClip:= True;
        ClipBoard.AsText:= ListBox1.Items[ListBox1.ItemIndex];
        ListBox1.Items.Delete(ListBox1.ItemIndex);
    End;
End;

Procedure TLCalc.N1Click(Sender: TObject);
Begin
    Config.ListBoxClip:= False;
    If Edit1.Focused Then
        Edit1.CopyToClipBoard
    Else If ListBox1.Focused And (ListBox1.ItemIndex >= 0) Then Begin
        ClipBoard.AsText:= ListBox1.Items[ListBox1.ItemIndex];
        Config.ListBoxClip:= True;
    End;
End;

Procedure TLCalc.N3Click(Sender: TObject);
Begin
    If Not ClipBoard.HasFormat(CF_Text) Then Exit;
    If Edit1.Focused Then Edit1.PasteFromClipBoard;
End;

Procedure TLCalc.PopupMenu1Popup(Sender: TObject);
Begin
    If ListBox1.Focused Then
        LCalc.N3.Enabled:= False
    Else
        LCalc.N3.Enabled:= True;
    If Config.UserSystem > 0 Then Begin
        UserBase.Caption:= UserSystemText + ' (' + IntToStr(Config.UserSystem) + ')';
    End
    Else Begin
        UserBase.Caption:= UserSystemText;
    End;
End;

Procedure TLCalc.N4Click(Sender: TObject);
Begin
    If ListBox1.Focused And (ListBox1.ItemIndex >= 0) Then
        ListBox1.Items.Delete(ListBox1.ItemIndex)
    Else If Edit1.Focused Then
        Edit1.ClearSelection;
End;

Procedure TLCalc.C1Click(Sender: TObject);
Begin
    With Config Do Begin
        SetCurrentFont(EditFont, ListBoxFont);
        SetCurrentWindow;
        Write;
    End;
End;

Procedure TLCalc.N18Click(Sender: TObject);
Begin
    Config.EditAutoSelect:= Not Config.EditAutoSelect;
    N18.Checked:= Not N18.Checked;
End;

Procedure TLCalc.N21Click(Sender: TObject);
Begin
    FontDialog1.Font.Assign(Edit1.Font);
    If FontDialog1.Execute Then With Config Do Begin
        Edit1.Font.Assign(FontDialog1.Font);
        SetCurrentFont(EditFont, ListBoxFont);
        ApplyFont(EditFont, ListBoxFont);
        Resize;
    End;
End;

Procedure TLCalc.N22Click(Sender: TObject);
Begin
    FontDialog1.Font.Assign(ListBox1.Font);
    If FontDialog1.Execute Then With Config Do Begin
        ListBox1.Font.Assign(FontDialog1.Font);
        SetCurrentFont(EditFont, ListBoxFont);
        ApplyFont(EditFont, ListBoxFont);
        Resize;
    End;
End;

Procedure TLCalc.N24Click(Sender: TObject);
Begin
    If ColorDialog1.Execute Then Begin
        Config.EditColor:= ColorDialog1.Color;
        Edit1.Color:= Config.EditColor;
    End;
End;

Procedure TLCalc.N26Click(Sender: TObject);
Begin
    If ColorDialog1.Execute Then Begin
        Config.FormColor:= ColorDialog1.Color;
        LCalc.Color:= Config.FormColor;
    End;
End;

Procedure TLCalc.N25Click(Sender: TObject);
Begin
    If ColorDialog1.Execute Then Begin
        Config.ListBoxColor:= ColorDialog1.Color;
        ListBox1.Color:= Config.ListBoxColor;
    End;
End;

Procedure TLCalc.N31Click(Sender: TObject);
Begin
    Config.ChainCalculation:= Not Config.ChainCalculation;
    N31.Checked:= Config.ChainCalculation;
End;

Procedure TLCalc.N28Click(Sender: TObject);
Var VarC: Word;
Begin
    SaveDialog1.Filter:= VarFilter;
    OpenDialog1.DefaultExt:= 'LCV';
    If FName = '' Then If SaveDialog1.Execute Then
        FName:= SaveDialog1.FileName
    Else
        Exit;
    Try
        AssignFile(FD, FName);
        ReWrite(FD, 1);
        VarC:= GetVarCount;
        BlockWrite(FD, VarC, SizeOf(VarC));
        BlockWrite(FD, Vars, SizeOf(Vars));
        CloseFile(FD);
        ListBox1.Items.Add(' ');
    Except
        ListBox1.Items.Add('  c ');
    End;
End;

Procedure TLCalc.N30Click(Sender: TObject);
Var VarC: Word;
Begin
    OpenDialog1.Filter:= VarFilter;
    OpenDialog1.DefaultExt:= 'LCV';
    If Not OpenDialog1.Execute Then
        Exit
    Else Try
        FName:= OpenDialog1.FileName;
        AssignFile(FD, FName);
        Reset(FD, 1);
        BlockRead(FD, VarC, SizeOf(VarC));
        SetVarCount(VarC);
        BlockRead(FD, Vars[0], SizeOf(Vars));
        CloseFile(FD);
        ListBox1.Items.Add(' ');
        VarF.UpDateIt;
    Except
        ListBox1.Items.Add('   ');
    End;
End;

Procedure TLCalc.N29Click(Sender: TObject);
Begin
    FName:= '';
    N28Click(LCalc);
End;

Procedure TLCalc.N33Click(Sender: TObject);
Begin
    OpenDialog1.Filter:= LogFilter;
    OpenDialog1.DefaultExt:= 'LCL';
    If Not OpenDialog1.Execute Then
        Exit
    Else Try
        LogFName:= OpenDialog1.FileName;
        ListBox1.Items.LoadFromFile(LogFName);
    Except
        ListBox1.Items.Add('   ');
    End;
End;

Procedure TLCalc.N34Click(Sender: TObject);
Begin
    SaveDialog1.Filter:= LogFilter;
    OpenDialog1.DefaultExt:= 'LCL';
    If LogFName = '' Then If SaveDialog1.Execute Then
        LogFName:= SaveDialog1.FileName
    Else
        Exit;
    Try
        ListBox1.Items.SaveToFile(LogFName);
    Except
        ListBox1.Items.Add('   ');
    End;
End;

Procedure TLCalc.N35Click(Sender: TObject);
Begin
    LogFName:= '';
    N34Click(LCalc);
End;

Procedure TLCalc.Bin1Click(Sender: TObject);
Begin
    Config.CountSystem:= TBin;
    Bin1.Checked:= True; Hex1.Checked:= False;
    Dec1.Checked:= False; All1.Checked:= False;
    Oct1.Checked:= False; UserBase.Checked:= False;
End;

Procedure TLCalc.Dec1Click(Sender: TObject);
Begin
    Config.CountSystem:= TDec;
    Bin1.Checked:= False; Hex1.Checked:= False;
    Dec1.Checked:= True; All1.Checked:= False;
    Oct1.Checked:= False; UserBase.Checked:= False;
End;

Procedure TLCalc.Hex1Click(Sender: TObject);
Begin
    Config.CountSystem:= THex;
    Bin1.Checked:= False; Hex1.Checked:= True;
    Dec1.Checked:= False; All1.Checked:= False;
    Oct1.Checked:= False; UserBase.Checked:= False;
End;

Procedure TLCalc.All1Click(Sender: TObject);
Begin
    Config.CountSystem:= TAll;
    Bin1.Checked:= False; Hex1.Checked:= False;
    Dec1.Checked:= False; All1.Checked:= True;
    Oct1.Checked:= False; UserBase.Checked:= False;
End;

Procedure TLCalc.Oct1Click(Sender: TObject);
Begin
    Config.CountSystem:= TOct;
    Bin1.Checked:= False; Hex1.Checked:= False;
    Dec1.Checked:= False; All1.Checked:= False;
    Oct1.Checked:= True; UserBase.Checked:= False;
End;

Procedure TLCalc.Disable;
Begin
    Enabled:= False;
End;

Procedure TLCalc.Enable;
Begin
    Enabled:= True;
End;

Procedure TLCalc.N40Click(Sender: TObject);
Begin
    If Application.MessageBox(' ?', 'LeftCalc', MB_YesNo) = IDYes Then
    DeleteFile('LeftCalc.Bin');
End;

Procedure TLCalc.N41Click(Sender: TObject);
Begin
    InputForm.GetNumber(AppName, '    .' +
    ' , 3 -  , 6 -  . 0 - ');
End;

Procedure TLCalc.UserBaseClick(Sender: TObject);
Begin
    If Config.UserSystem = 0 Then N41.Click;
    If Config.UserSystem = 0 Then Exit;
    Config.CountSystem:= TUser;
    Bin1.Checked:= False; Hex1.Checked:= False;
    Dec1.Checked:= False; All1.Checked:= False;
    Oct1.Checked:= False; UserBase.Checked:= True;
End;

Procedure TLCalc.N42Click(Sender: TObject);
Begin
    Config.CaptResult:= Not Config.CaptResult;
    N42.Checked:= Config.CaptResult;
    If Not Config.CaptResult Then LCalc.Caption:= AppName;
End;

Procedure TLCalc.CSCheck;
Begin
    With Config Do Begin
        Oct1.Checked:= CountSystem = TOct;
        Bin1.Checked:= CountSystem = TBin;
        Hex1.Checked:= CountSystem = THex;
        Dec1.Checked:= CountSystem = TDec;
        All1.Checked:= CountSystem = TAll;
        UserBase.Checked:= CountSystem = TUser;
    End;
End;

Procedure TLCalc.N38Click(Sender: TObject);
Begin
    Config.VarPanelActive:= Not Config.VarPanelActive;
    N38.Checked:= Config.VarPanelActive;
    If Config.VarPanelActive Then
        VarF.Show
    Else
        VarF.Hide;
End;

Procedure TLCalc.N44Click(Sender: TObject);
Begin
    VarF.Left:= LCalc.Left + LCalc.Width;
    VarF.Top:= LCalc.Top;
    ButtF.Top:= LCalc.Top + LCalc.Height;
    ButtF.Left:= LCalc.Left;
End;

Procedure TLCalc.N37Click(Sender: TObject);
Begin
    Config.ButPanelActive:= Not Config.ButPanelActive;
    N37.Checked:= Config.ButPanelActive;
    If Config.ButPanelActive Then
        ButtF.Show
    Else
        ButtF.Hide;
End;

Procedure TLCalc.N15Click(Sender: TObject);
Begin
    HelpF.Show;
End;

Procedure TLCalc.N16Click(Sender: TObject);
Begin
    AboutF.Show;
End;

Initialization
Begin
    FName:= ''; LogFName:= '';
End;
End.
