Unit VarsF;
Interface
Uses
    SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
    Forms, Dialogs, StdCtrls, LCore2;
Type
    TVarF = Class(TForm)
        GroupBox2: TGroupBox;
        ListBox1: TListBox;
        Procedure FormResize(Sender: TObject);
        Procedure ListBox1DblClick(Sender: TObject);
        Procedure FormCreate(Sender: TObject);
        Procedure FormHide(Sender: TObject);
        Procedure UpdateIt;
    End;

Implementation
Uses
    LCalc3;
{$R *.DFM}

Procedure TVarF.UpDateIt;
Var Temp: Word;
Begin
    ListBox1.Clear;
    For Temp:= 1 To VarCount Do ListBox1.Items.Add(Vars[Temp].Name + '=' + FloatToStr(Vars[Temp].Value));
End;

Procedure TVarF.FormResize(Sender: TObject);
Begin
    GroupBox2.Width:= Width - 24;
    ListBox1.Width:= GroupBox2.Width - 16;
    GroupBox2.Height:= Height - 32;
    ListBox1.Height:= GroupBox2.Height - 24;
End;

Procedure TVarF.ListBox1DblClick(Sender: TObject);
Begin
    LCalc.Edit1.Text:= LCalc.Edit1.Text + Vars[ListBox1.ItemIndex + 1].Name;
    LCalc.Edit1.SelStart:= Length(LCalc.Edit1.Text);
    LCalc.SetFocus;
End;

Procedure TVarF.FormCreate(Sender: TObject);
Begin
    With Config.VarsWindow Do Begin
        Width:= FormWidth; Height:= FormHeight;
        Left:= FormLeft; Top:= FormTop;
        If FormMax Then WindowState:= WSMaximized;
    End;
    If Config.VarPanelActive Then
        VarF.Show
    Else
        VarF.Hide;
    VarF.PopupMenu:= LCalc.PopupMenu;
End;

Procedure TVarF.FormHide(Sender: TObject);
Begin
    With Config Do Begin
        VarPanelActive:= False;
        LCalc.N38.Checked:= False;
    End;
End;

End.
